module Donate.Methods.LiberaPay exposing (..)

import Donate.Types exposing (..)


donateLiberaPay : Donate
donateLiberaPay =
    let
        name : String
        name =
            "LiberaPay"
    in
    { donateImage = formatName name
    , donateLink = "https://liberapay.com/TheNutrivore"
    , donateName = name
    , donateFees = "0%"
    , donatePreference = 10
    , donateFeatures =
        [ { free = Just True
          , subscriptions = Just True
          , openSource = Just True
          , fastPayments = Just False
          , userFriendly = Just True
          , anonymous = Just True
          , rewardTiers = Just True
          }
        ]
    , donatePros =
        [ { pro = "Open-source platform."
          }
        , { pro = "Focuses on privacy and transparency."
          }
        , { pro = "Allows weekly recurring donations."
          }
        , { pro = "Creator-friendly with no platform charges."
          }
        ]
    , donateCons =
        [ { con = "Less mainstream compared to other platforms."
          }
        , { con = "Fewer features compared to more established platforms."
          }
        , { con = "Requires users to be comfortable with a less-known service."
          }
        ]
    }
